import 'dart:mirrors';

import 'package:neuro/instance.dart';

void autowire(value){
  ClassMirror classMirror = reflectClass(value.runtimeType);
  Map<Symbol, DeclarationMirror> declarations = classMirror.declarations;
  InstanceMirror instanceMirror = reflect(value);
  declarations.forEach((key, value) {
    String name = MirrorSystem.getName(value.simpleName);
    if(name.startsWith("handle")){
      InstanceMirror instanceM = reflect(instanceMirror.getField(key));
      if(instanceM.reflectee is ClosureMirror){
        ClosureMirror closureMirror = instanceM.reflectee;
        // todo ensure that argument count == 1
        var closureReflectee = closureMirror.reflectee;
        if (closureReflectee is Function) {
          neuro.handle((arg) async {
            return closureReflectee.call(arg);
          });
        }
      }
    }
  });
}